Attribute VB_Name = "modSpeedUp"


'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

#If False Then
Public Function Join( _
  ByRef sArray() As String, _
  Optional ByRef Delimiter As String = " " _
) As String
    Dim JoinLen       As Long
    Dim JoinPtr       As Long
    Dim DelimiterLen  As Long
    Dim LB            As Long
    Dim UB            As Long
    Dim I             As Long
    
    LB = LBound(sArray)
    UB = UBound(sArray)
    For I = LB To UB
        JoinLen = JoinLen + LenB(sArray(I))
    Next I
    
    JoinPtr = 1
    DelimiterLen = LenB(Delimiter)
    If CBool(DelimiterLen) Then
        JoinLen = JoinLen + DelimiterLen * (UB - LB)
        Join = Space$(JoinLen \ 2)
        
        For I = LB To UB - 1
            MidB$(Join, JoinPtr) = sArray(I)
            JoinPtr = JoinPtr + LenB(sArray(I))
            MidB$(Join, JoinPtr) = Delimiter
            JoinPtr = JoinPtr + DelimiterLen
        Next I
        
        MidB$(Join, JoinPtr) = sArray(I)
    Else
        Join = Space$(JoinLen \ 2)
        
        For I = LB To UB
            MidB$(Join, JoinPtr) = sArray(I)
            JoinPtr = JoinPtr + LenB(sArray(I))
        Next I
    End If ' CBool(DelimiterLen)
End Function
#End If

Public Function Split( _
  ByRef Expression As String, _
  Optional ByRef Delimiter As String = " ", _
  Optional ByVal Count As Long = -1, _
  Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
) As String()
    Dim DelimiterLen    As Long
    Dim Index           As Long
    Dim Start           As Long
    Dim Strings()       As String
    Dim StringsCount    As Long
    Dim StringsUBound   As Long
    
    If CBool(Count) And CBool(LenB(Expression)) Then
        DelimiterLen = LenB(Delimiter)
        If DelimiterLen Then
            ' reserve memory
            If Count < 0 Then
                Count = LenB(Expression) \ DelimiterLen
            Else
                Count = Count - 1
            End If
            
            If Count < 2048 Then
                StringsUBound = Count
            Else
                StringsUBound = 1024
            End If
            
            ReDim Strings(StringsUBound)
            
            ' split string
            Start = 1
            For StringsCount = 0 To Count - 1
                ' get next delimiter
                Index = InStrB(Start, Expression, Delimiter, Compare)
                If Index = 0 Then _
                    Exit For
                
                ' enlarge array, if required
                If StringsCount > StringsUBound Then
                    StringsUBound = StringsCount * 2
                    ReDim Preserve Strings(StringsUBound)
                End If
                
                ' save string part
                Strings(StringsCount) = _
                    MidB$(Expression, Start, Index - Start)
                Start = Index + DelimiterLen
            Next StringsCount
            
            Strings(StringsCount) = MidB$(Expression, Start)
            
            ' squeeze array, if required
            If StringsCount < StringsUBound Then _
                ReDim Preserve Strings(StringsCount)
        Else
            ' delimiter is null string
            ReDim Strings(0)
            Strings(0) = Expression
        End If 'DelimiterLen
        
        Split = Strings
    Else
        ' nothing 2 do
        'Split = Array()
    End If ' CBool(Count) And CBool(LenB(Expression))
End Function

Public Function Replace( _
  ByRef Text As String, _
  ByRef sOld As String, _
  ByRef sNew As String, _
  Optional ByVal Start As Long = 1, _
  Optional ByVal Count As Long = 2147483647, _
  Optional ByVal Compare As VbCompareMethod = vbBinaryCompare _
) As String
    If CBool(LenB(sOld)) Then
        If Compare = vbBinaryCompare Then
            Call ReplaceBin( _
                Replace, Text, Text, _
                sOld, sNew, Start, Count _
            )
        Else
            Call ReplaceBin( _
                Replace, Text, LCase$(Text), _
                LCase$(sOld), sNew, Start, Count _
            )
        End If
    Else ' search string is MT
        Replace = Text
    End If ' CBool(LenB(sOld))
End Function

Private Static Sub ReplaceBin( _
  ByRef Result As String, _
  ByRef Text As String, _
  ByRef Search As String, _
  ByRef sOld As String, _
  ByRef sNew As String, _
  ByVal Start As Long, _
  ByVal Count As Long _
)
    Dim TextLen         As Long
    Dim OldLen          As Long
    Dim NewLen          As Long
    Dim ReadPos         As Long
    Dim WritePos        As Long
    Dim CopyLen         As Long
    Dim Buffer          As String
    Dim BufferLen       As Long
    Dim BufferPosNew    As Long
    Dim BufferPosNext   As Long
    
    ' get first target
    If Start < 2 Then
        Start = InStrB(Search, sOld)
    Else
        Start = InStrB(Start + Start - 1, Search, sOld)
    End If
    
    If CBool(Start) Then
        OldLen = LenB(sOld)
        NewLen = LenB(sNew)
        
        Select Case NewLen
            Case OldLen ' simple overwrite
                Result = Text
                
                For Count = 1 To Count
                    MidB$(Result, Start) = sNew
                    Start = InStrB(Start + OldLen, Search, sOld)
                    
                    If Start = 0 Then _
                        Exit Sub
                Next Count
                
                Exit Sub
            
            Case Is < OldLen ' result is shorter
                ' initialize buffer
                TextLen = LenB(Text)
                
                If TextLen > BufferLen Then
                    Buffer = Text
                    BufferLen = TextLen
                End If
                
                ' replace
                ReadPos = 1
                WritePos = 1
                
                If NewLen Then
                    ' pay attention to text to be inserted
                    For Count = 1 To Count
                        CopyLen = Start - ReadPos
                        
                        If CopyLen Then
                            BufferPosNew = WritePos + CopyLen
                            MidB$(Buffer, WritePos) = MidB$(Text, ReadPos, CopyLen)
                            MidB$(Buffer, BufferPosNew) = sNew
                            WritePos = BufferPosNew + NewLen
                        Else
                            MidB$(Buffer, WritePos) = sNew
                            WritePos = WritePos + NewLen
                        End If
                        
                        ReadPos = Start + OldLen
                        Start = InStrB(ReadPos, Search, sOld)
                        If Start = 0 Then _
                            Exit For
                    Next Count
                Else
                    ' ignore text to insert (because MT)
                    For Count = 1 To Count
                        CopyLen = Start - ReadPos
                        
                        If CopyLen Then
                            MidB$(Buffer, WritePos) = MidB$(Text, ReadPos, CopyLen)
                            WritePos = WritePos + CopyLen
                        End If
                        
                        ReadPos = Start + OldLen
                        Start = InStrB(ReadPos, Search, sOld)
                        If Start = 0 Then _
                            Exit For
                    Next Count
                End If
                
                ' compile result
                If ReadPos > TextLen Then
                    Result = LeftB$(Buffer, WritePos - 1)
                Else
                    MidB$(Buffer, WritePos) = MidB$(Text, ReadPos)
                    Result = LeftB$(Buffer, WritePos + LenB(Text) - ReadPos)
                End If
                
                Exit Sub
            Case Else ' result will be longer
                ' initialize buffer
                TextLen = LenB(Text)
                BufferPosNew = TextLen + NewLen
                
                If BufferPosNew > BufferLen Then
                    Buffer = Space$(BufferPosNew)
                    BufferLen = LenB(Buffer)
                End If
                
                ' replace
                ReadPos = 1
                WritePos = 1
                
                For Count = 1 To Count
                    CopyLen = Start - ReadPos
                    
                    If CopyLen Then
                        ' calculate position
                        BufferPosNew = WritePos + CopyLen
                        BufferPosNext = BufferPosNew + NewLen
                        
                        ' enlarge buffer, if required
                        If BufferPosNext > BufferLen Then
                            Buffer = Buffer & Space$(BufferPosNext)
                            BufferLen = LenB(Buffer)
                        End If
                        
                        ' "patch" string
                        MidB$(Buffer, WritePos) = MidB$(Text, ReadPos, CopyLen)
                        MidB$(Buffer, BufferPosNew) = sNew
                    Else
                        ' calculate position
                        BufferPosNext = WritePos + NewLen
                        
                        ' enlarge buffer, if required
                        If BufferPosNext > BufferLen Then
                            Buffer = Buffer & Space$(BufferPosNext)
                            BufferLen = LenB(Buffer)
                        End If
                        
                        ' "patch" string
                        MidB$(Buffer, WritePos) = sNew
                    End If
                    
                    WritePos = BufferPosNext
                    ReadPos = Start + OldLen
                    Start = InStrB(ReadPos, Search, sOld)
                    
                    If Start = 0 Then _
                        Exit For
                Next Count
                
                ' compile result
                If ReadPos > TextLen Then
                    Result = LeftB$(Buffer, WritePos - 1)
                Else
                    BufferPosNext = WritePos + TextLen - ReadPos
                    
                    If BufferPosNext < BufferLen Then
                        MidB$(Buffer, WritePos) = MidB$(Text, ReadPos)
                        Result = LeftB$(Buffer, BufferPosNext)
                    Else
                        Result = LeftB$(Buffer, WritePos - 1) & MidB$(Text, ReadPos)
                    End If
                End If
                
                Exit Sub
        End Select
    Else ' nothing found
        Result = Text
    End If
End Sub

